/*****************************************************************************/
/* Betriebssysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                                 B E L L                                   */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* Eine "Glocke" ist eine abstrakte Basisklasse, die das Ausloesen einer     */
/* Aktivitaet nach einer bestimmten Wartezeit erlaubt.                       */
/* Dazu besitzt sie einen Zaehler, der vom "Gloeckner" (Bellringer) ver-     */
/* waltet wird.                                                              */
/*****************************************************************************/

#ifndef __Bell_include__
#define __Bell_include__

#include "object/chain.h"
        
class Bell 
 : public Chain
 {
    int counter;
public:
    // WAIT: Setzen bzw. Abfragen des Zaehlers
    void wait (int value) { counter = value; }
    int wait () { return counter; }

    // TICK: Dekrementieren des Zaehlers um 1
    void tick () { counter--; }

    // RUN_DOWN: Abfragen, ob die Zeit abgelaufen ist
    bool run_down () { return counter <= 0; }

    // RING: Wird vom "Gloeckner" aufgerufen, wenn es an der Zeit ist
    virtual void ring () = 0;
 };

#endif
