/*****************************************************************************/
/* Betriebssysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                          B E L L R I N G E R                              */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* Der "Gloeckner" wird im Rahmen der Timer-Epilog Bearbeitung aktiviert.    */
/* Er prueft, ob irgendwelche Glocken (Bell-Objekte) laeuten muessen. Die    */
/* Glocken befinden sich in einer Liste, die der Gloeckner verwaltet.        */
/*****************************************************************************/

#ifndef __Bellringer_include__
#define __Bellringer_include__

#include "meeting/bell.h"
#include "object/list.h"
        
class Bellringer 
 : private List
 {
   // RING_THE_BELLS: Laeuten der Glocken
    void ring_the_bells ();

public:
   // CHECK: Prueft, ob Glocken zu laeuten sind und tut es gegebenenfalls
   void check ();

   // JOB: Eine Glocke wird dem Gloeckner ueberantwortet. Sie muss nach
   //      einer bestimmten Zeit gelaeutet werden.
   void job (Bell *bell, int ticks);

   // CANCEL: Eine bestimmte Glocke soll nun doch nicht gelaeutet werden
   void cancel (Bell *bell);
 };

#endif
