/*****************************************************************************/
/* Betriebssysteme                                                           */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*                               B U Z Z E R                                 */
/*                                                                           */
/*---------------------------------------------------------------------------*/
/* Mit Hilfe des "Weckers" koennen Prozesse eine bestimmte Zeit lang         */
/* schlafen und sich dann wecken lassen.                                     */
/*****************************************************************************/

#ifndef __Buzzer_include__
#define __Buzzer_include__

#include "meeting/waitingroom.h"
#include "meeting/bell.h"

class Buzzer 
 : public Waitingroom, public Bell
 {
    bool on;
public:
    // KONSTRUKTOR: Der Wecker ist zunaechst noch abgeschaltet
    Buzzer () : on (false) {}

    // DESTRUKTOR: Den Gloeckner informieren, das er hier nicht mehr laeuten
    //             muss
    virtual ~Buzzer ();

    // RING: Die Wartezeit ist abgelaufen.
    void ring ();

    // SET: Stellen des Weckers
    void set (int ms);

    // SLEEP: Schlafen bis der Wecker klingel.
    void sleep ();
 };

#endif
