/*---------------------------------------------------------------------------*
 * Operating Systems I                                                       *
 *---------------------------------------------------------------------------*
 *                                                                           *
 *                        G U A R D E D _ B U Z Z E R                        *
 *                                                                           *
 *---------------------------------------------------------------------------*/

/* INCLUDES             */
#include "syscall/guarded_buzzer.h"
#include "guard/secure.h"

/* METHODS              */
Guarded_Buzzer::~Guarded_Buzzer () {
  Secure section;
  this->Buzzer::~Buzzer ();
}
      
void Guarded_Buzzer::set (int ms) {
  Secure section;
  Buzzer::set (ms);
}

void Guarded_Buzzer::sleep () {
  Secure section;
  Buzzer::sleep ();
}
