/*---------------------------------------------------------------------------*
 * Operating Systems I                                                       *
 *---------------------------------------------------------------------------*
 *                                                                           *
 *                        G U A R D E D _ B U Z Z E R                        *
 *                                                                           *
 *---------------------------------------------------------------------------*/

#ifndef __Guarded_Buzzer_include__
#define __Guarded_Buzzer_include__

#include "meeting/buzzer.h"
        
/**
 * Implementation of the interface of buzzer-objects for user threads.
 */
class Guarded_Buzzer : public Buzzer {
public:
  /**
   * Destructor of Guarded_Buzzer wakes all waiting Thread and informs the 
   * Bellringer.
   */
  ~Guarded_Buzzer ();

  /**
   * Sets the alarm of the Buzzer.
   */
  void set (int ms);

  /**
   * Sets the Buzzer to sleep until the alarm is set of.
   */
  void sleep ();
};

#endif
